diff --git a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityChest.java b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityChest.java
index 43b4edcb5..3c7504611 100644
--- a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityChest.java
+++ b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityChest.java
@@ -125,7 +125,7 @@ public class TileEntityChest extends TileEntity
     @Override
 	public boolean stillValid(Player entityplayer)
     {
-        if(worldObj.getBlockEntity(x, y, z) != this)
+        if(worldObj == null || worldObj.getTileEntity(x, y, z) != this)
         {
             return false;
         }
diff --git a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityDispenser.java b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityDispenser.java
index cc9692308..cb993fea7 100644
--- a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityDispenser.java
+++ b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityDispenser.java
@@ -157,7 +157,7 @@ public class TileEntityDispenser extends TileEntity
     @Override
 	public boolean stillValid(Player entityplayer)
     {
-        if(worldObj.getBlockEntity(x, y, z) != this)
+        if(worldObj == null || worldObj.getTileEntity(x, y, z) != this)
         {
             return false;
         }
diff --git a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityFlag.java b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityFlag.java
index dc88c5ca3..e28a08896 100644
--- a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityFlag.java
+++ b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityFlag.java
@@ -10,7 +10,7 @@ import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.item.Items;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.net.packet.Packet;
-import net.minecraft.core.net.packet.PacketBlockEntityData;
+import net.minecraft.core.net.packet.PacketTileEntityData;
 import net.minecraft.core.player.inventory.container.Container;
 import net.minecraft.core.util.helper.UUIDHelper;
 import org.jetbrains.annotations.Nullable;
@@ -237,7 +237,7 @@ public class TileEntityFlag extends TileEntity
 
     @Override
     public Packet getDescriptionPacket() {
-        return new PacketBlockEntityData(this);
+        return new PacketTileEntityData(this);
     }
 
     @Override
@@ -275,7 +275,7 @@ public class TileEntityFlag extends TileEntity
     @Override
     public boolean stillValid(Player entityplayer)
     {
-        if(worldObj.getBlockEntity(x, y, z) != this)
+        if(worldObj == null || worldObj.getTileEntity(x, y, z) != this)
         {
             return false;
         }
diff --git a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityFlowerJar.java b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityFlowerJar.java
index e1d943d51..6b1995c3a 100644
--- a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityFlowerJar.java
+++ b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityFlowerJar.java
@@ -7,7 +7,7 @@ import net.minecraft.core.block.Blocks;
 import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.net.packet.Packet;
-import net.minecraft.core.net.packet.PacketBlockEntityData;
+import net.minecraft.core.net.packet.PacketTileEntityData;
 import net.minecraft.core.world.World;
 
 public class TileEntityFlowerJar extends TileEntity {
@@ -48,7 +48,7 @@ public class TileEntityFlowerJar extends TileEntity {
 
     @Override
     public Packet getDescriptionPacket() {
-        return new PacketBlockEntityData(this);
+        return new PacketTileEntityData(this);
     }
 
 }
\ No newline at end of file
diff --git a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityFurnace.java b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityFurnace.java
index 4197fd6c3..154efaccd 100644
--- a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityFurnace.java
+++ b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityFurnace.java
@@ -14,7 +14,7 @@ import net.minecraft.core.entity.EntityItem;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.item.Items;
 import net.minecraft.core.item.ItemStack;
-import net.minecraft.core.net.packet.PacketBlockEntityData;
+import net.minecraft.core.net.packet.PacketTileEntityData;
 import net.minecraft.core.net.packet.Packet;
 import net.minecraft.core.player.inventory.container.Container;
 import net.minecraft.core.util.helper.Side;
@@ -322,7 +322,7 @@ public class TileEntityFurnace extends TileEntity
     @Override
 	public boolean stillValid(Player entityplayer)
     {
-        if(worldObj.getBlockEntity(x, y, z) != this)
+        if(worldObj == null || worldObj.getTileEntity(x, y, z) != this)
         {
             return false;
         }
@@ -371,7 +371,7 @@ public class TileEntityFurnace extends TileEntity
 
     @Override
     public Packet getDescriptionPacket() {
-        return new PacketBlockEntityData(this);
+        return new PacketTileEntityData(this);
     }
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityMeshGold.java b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityMeshGold.java
index bb153de03..9e1882d97 100644
--- a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityMeshGold.java
+++ b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityMeshGold.java
@@ -5,7 +5,7 @@ import net.minecraft.core.entity.EntityItem;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.net.packet.Packet;
-import net.minecraft.core.net.packet.PacketBlockEntityData;
+import net.minecraft.core.net.packet.PacketTileEntityData;
 import net.minecraft.core.world.World;
 import org.jetbrains.annotations.Nullable;
 
@@ -79,6 +79,6 @@ public class TileEntityMeshGold extends TileEntity {
 
     @Override
     public Packet getDescriptionPacket() {
-        return new PacketBlockEntityData(this);
+        return new PacketTileEntityData(this);
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntitySign.java b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntitySign.java
index 868556838..d32e914b4 100644
--- a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntitySign.java
+++ b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntitySign.java
@@ -5,7 +5,7 @@ import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.EnumSignPicture;
 import net.minecraft.core.net.command.TextFormatting;
 import net.minecraft.core.net.packet.Packet;
-import net.minecraft.core.net.packet.PacketBlockEntityData;
+import net.minecraft.core.net.packet.PacketTileEntityData;
 import net.minecraft.core.util.helper.UUIDHelper;
 import org.jetbrains.annotations.Nullable;
 
@@ -124,7 +124,7 @@ public class TileEntitySign extends TileEntity
     @Override
 	public Packet getDescriptionPacket()
     {
-        return new PacketBlockEntityData(this);
+        return new PacketTileEntityData(this);
     }
 
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityStatue.java b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityStatue.java
index 232058293..e933f3b10 100644
--- a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityStatue.java
+++ b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityStatue.java
@@ -5,20 +5,24 @@ import com.mojang.nbt.tags.CompoundTag;
 import com.mojang.nbt.tags.ListTag;
 import com.mojang.nbt.tags.Tag;
 import net.minecraft.core.entity.IArmorWearing;
+import net.minecraft.core.entity.IItemHolding;
 import net.minecraft.core.enums.HumanArmorShape;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.net.packet.Packet;
-import net.minecraft.core.net.packet.PacketBlockEntityData;
+import net.minecraft.core.net.packet.PacketTileEntityData;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
-public class TileEntityStatue extends TileEntity implements IArmorWearing<HumanArmorShape> {
+public class TileEntityStatue
+    extends TileEntity
+    implements IArmorWearing<HumanArmorShape>, IItemHolding {
+
     public enum Pose {
         DEFAULT(0.0f, 0.0f, 0.0f, 0.0f, 0.0f, 0.0f),
         LEFT_ARM_UP(-2.2f, 0.0f, 0.0f, 0.0f, 0.0f, 0.0f),
         RIGHT_ARM_UP(0.0f, -2.2f, 0.0f, 0.0f, 0.0f, 0.0f),
         BOTH_ARMS_UP(-2.2f, -2.2f, 0.0f, 0.0f, 0.0f, 0.0f),
-        WALKING(0.75f, -0.75f, 0.5f, -0.5f, 0.0f, 0.0f),
+        WALKING(0.75f, -0.75f, -0.5f, 0.5f, 0.0f, 0.0f),
         LOOK_UP(0.0f, 0.0f, 0.0f, 0.0f, -0.3f, 0.0f),
         LOOK_DOWN(0.0f, 0.0f, 0.0f, 0.0f, 0.3f, 0.0f),
         LOOK_LEFT(0.0f, 0.0f, 0.0f, 0.0f, 0.0f, -1.0f),
@@ -43,12 +47,14 @@ public class TileEntityStatue extends TileEntity implements IArmorWearing<HumanA
     }
 
     private final @Nullable ItemStack @NotNull[] armorPieces = new ItemStack[HumanArmorShape.values().length];
+    private @Nullable ItemStack heldItem = null;
     private @NotNull Pose pose = Pose.DEFAULT;
 
     @Override
     public void writeToNBT(CompoundTag tag) {
         super.writeToNBT(tag);
 
+        // Write armor
         final @NotNull ListTag list = new ListTag();
         for (int i = 0; i < getNumArmorSlots(); i++) {
             final @Nullable HumanArmorShape slot = getArmorSlotByIndex(i);
@@ -63,13 +69,23 @@ public class TileEntityStatue extends TileEntity implements IArmorWearing<HumanA
             }
         }
         tag.putList("Armor", list);
+
+        // Write pose
         tag.putByte("Pose", (byte) this.pose.ordinal());
+
+        // Write held item
+        if (getHeldItem() != null) {
+            final @NotNull CompoundTag heldItemTag = new CompoundTag();
+            getHeldItem().writeToNBT(heldItemTag);
+            tag.putCompound("HeldItem", heldItemTag);
+        }
     }
 
     @Override
     public void readFromNBT(CompoundTag tag) {
         super.readFromNBT(tag);
 
+        // Read armor
         final @Nullable ListTag list = tag.getList("Armor");
         if (list != null) {
             for (Tag<?> t : list) {
@@ -89,11 +105,21 @@ public class TileEntityStatue extends TileEntity implements IArmorWearing<HumanA
             }
         }
 
+        // Read pose
         byte pose = tag.getByteOrDefault("Pose", (byte) Pose.DEFAULT.ordinal());
         if (pose < 0 || pose >= Pose.values().length) {
             pose = (byte) Pose.DEFAULT.ordinal();
         }
         this.pose = Pose.values()[pose];
+
+        // Read held item
+        final @Nullable CompoundTag heldItemTag = tag.getCompoundOrDefault("HeldItem", null);
+        if (heldItemTag != null) {
+            final @Nullable ItemStack heldItem = ItemStack.readItemStackFromNbt(heldItemTag);
+            if (heldItem != null) {
+                setHeldItem(heldItem);
+            }
+        }
     }
 
     public @NotNull Pose getPose() {
@@ -133,8 +159,23 @@ public class TileEntityStatue extends TileEntity implements IArmorWearing<HumanA
         return HumanArmorShape.values()[index];
     }
 
+    @Override
+    public @Nullable ItemStack getHeldItem() {
+        return this.heldItem;
+    }
+
+    @Override
+    public void setHeldItem(@Nullable ItemStack item) {
+        this.heldItem = item;
+    }
+
+    @Override
+    public boolean isLeftHanded() {
+        return false;
+    }
+
     @Override
     public Packet getDescriptionPacket() {
-        return new PacketBlockEntityData(this);
+        return new PacketTileEntityData(this);
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityTrommel.java b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityTrommel.java
index 0c87fde72..d2c26dfd3 100644
--- a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityTrommel.java
+++ b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityTrommel.java
@@ -390,7 +390,7 @@ public class TileEntityTrommel extends TileEntity
     @Override
 	public boolean stillValid(Player entityplayer)
     {
-        if(worldObj.getBlockEntity(x, y, z) != this)
+        if(worldObj == null || worldObj.getTileEntity(x, y, z) != this)
         {
             return false;
         }
@@ -407,7 +407,7 @@ public class TileEntityTrommel extends TileEntity
         super.dropContents(world, x, y, z);
         if (!BlockLogicTrommel.keepTrommelInventory)
         {
-            if(world.getBlockEntity(x, y, z) != null)
+            if(world.getTileEntity(x, y, z) != null)
             {
                 label0:
                 for (int l = 0; l < getContainerSize(); l++)
diff --git a/game/core/src/main/java/net/minecraft/core/block/piston/BlockLogicPistonBase.java b/game/core/src/main/java/net/minecraft/core/block/piston/BlockLogicPistonBase.java
index 357ff1c97..47cffcc7a 100644
--- a/game/core/src/main/java/net/minecraft/core/block/piston/BlockLogicPistonBase.java
+++ b/game/core/src/main/java/net/minecraft/core/block/piston/BlockLogicPistonBase.java
@@ -72,7 +72,7 @@ public class BlockLogicPistonBase extends BlockLogic
     @Override
 	public void onBlockPlacedByWorld(World world, int x, int y, int z)
     {
-        if(!world.isClientSide && world.getBlockEntity(x, y, z) == null)
+        if(!world.isClientSide && world.getTileEntity(x, y, z) == null)
         {
             checkIfExtend(world, x, y, z);
         }
@@ -164,7 +164,7 @@ public class BlockLogicPistonBase extends BlockLogic
     }
 
     public void retractEvent(World world, int x, int y, int z, int data, Direction direction) {
-        TileEntity tileEntity = world.getBlockEntity(x + direction.getOffsetX(), y + direction.getOffsetY(), z + direction.getOffsetZ());
+        TileEntity tileEntity = world.getTileEntity(x + direction.getOffsetX(), y + direction.getOffsetY(), z + direction.getOffsetZ());
         if((tileEntity instanceof TileEntityMovingPistonBlock))
         {
             TileEntityMovingPistonBlock moving = ((TileEntityMovingPistonBlock) tileEntity);
@@ -318,7 +318,7 @@ public class BlockLogicPistonBase extends BlockLogic
                 return false;
             }
             if (Blocks.blocksList[blockId].getPistonPushReaction(world, xo, yo, zo) == Material.PISTON_DESTROY_ON_PUSH) {
-                Blocks.blocksList[blockId].dropBlockWithCause(world, EnumDropCause.WORLD, xo, yo, zo, world.getBlockMetadata(xo, yo, zo), world.getBlockEntity(xo, yo, zo), null);
+                Blocks.blocksList[blockId].dropBlockWithCause(world, EnumDropCause.WORLD, xo, yo, zo, world.getBlockMetadata(xo, yo, zo), world.getTileEntity(xo, yo, zo), null);
                 break;
             }
             if (blocks == maxPushedBlocks) {
@@ -335,7 +335,7 @@ public class BlockLogicPistonBase extends BlockLogic
             int pz = zo - direction.getOffsetZ();
             int pushId = world.getBlockId(px, py, pz);
             int pushMeta = world.getBlockMetadata(px, py, pz);
-            TileEntity pushEntity = world.getBlockEntity(px, py, pz);
+            TileEntity pushEntity = world.getTileEntity(px, py, pz);
             if (pushEntity instanceof TileEntityMovingPistonBlock && px == x && py == y && pz == z) {
                 break;
             }
@@ -344,7 +344,7 @@ public class BlockLogicPistonBase extends BlockLogic
                 createPistonHeadAt(world, xo, yo, zo, data, direction);
             } else if (pushId == Blocks.PISTON_MOVING.id())
             {
-                TileEntity old = world.getBlockEntity(px, py, pz);
+                TileEntity old = world.getTileEntity(px, py, pz);
                 if (old instanceof TileEntityMovingPistonBlock) {
                     TileEntityMovingPistonBlock moving = (TileEntityMovingPistonBlock) old;
                     if (!moving.isSourcePiston()) {
diff --git a/game/core/src/main/java/net/minecraft/core/block/piston/BlockLogicPistonBaseSteel.java b/game/core/src/main/java/net/minecraft/core/block/piston/BlockLogicPistonBaseSteel.java
index dc3aaf49f..b24877e18 100644
--- a/game/core/src/main/java/net/minecraft/core/block/piston/BlockLogicPistonBaseSteel.java
+++ b/game/core/src/main/java/net/minecraft/core/block/piston/BlockLogicPistonBaseSteel.java
@@ -99,7 +99,7 @@ public class BlockLogicPistonBaseSteel extends BlockLogicPistonBase {
             Block<?> block = world.getBlock(xo, yo, zo);
             if (block == null) return true;
             int blockMeta = world.getBlockMetadata(xo, yo, zo);
-            TileEntity tileEntity = world.getBlockEntity(xo, yo, zo);
+            TileEntity tileEntity = world.getTileEntity(xo, yo, zo);
             world.removeBlockTileEntity(xo, yo, zo);
             world.setBlockWithNotify(xo, yo, zo, 0);
             if (!world.isClientSide) {
@@ -155,7 +155,7 @@ public class BlockLogicPistonBaseSteel extends BlockLogicPistonBase {
                     return false;
                 }
                 if (Blocks.blocksList[blockId].getPistonPushReaction(world, xo, yo, zo) == Material.PISTON_DESTROY_ON_PUSH) {
-                    Blocks.blocksList[blockId].dropBlockWithCause(world, EnumDropCause.WORLD, xo, yo, zo, world.getBlockMetadata(xo, yo, zo), world.getBlockEntity(xo, yo, zo), null);
+                    Blocks.blocksList[blockId].dropBlockWithCause(world, EnumDropCause.WORLD, xo, yo, zo, world.getBlockMetadata(xo, yo, zo), world.getTileEntity(xo, yo, zo), null);
                     break;
                 }
                 if (blocks == maxPushedBlocks) {
@@ -172,7 +172,7 @@ public class BlockLogicPistonBaseSteel extends BlockLogicPistonBase {
                     int py = yo - direction.getOffsetY();
                     int pz = zo - direction.getOffsetZ();
                     int pushId = world.getBlockId(px, py, pz);
-                    TileEntity pushEntity = world.getBlockEntity(px, py, pz);
+                    TileEntity pushEntity = world.getTileEntity(px, py, pz);
                     if (pushEntity instanceof TileEntityMovingPistonBlock && px == x && py == y && pz == z) {
                         break;
                     }
diff --git a/game/core/src/main/java/net/minecraft/core/block/piston/BlockLogicPistonBaseSticky.java b/game/core/src/main/java/net/minecraft/core/block/piston/BlockLogicPistonBaseSticky.java
index d10a577f1..72ee874a6 100644
--- a/game/core/src/main/java/net/minecraft/core/block/piston/BlockLogicPistonBaseSticky.java
+++ b/game/core/src/main/java/net/minecraft/core/block/piston/BlockLogicPistonBaseSticky.java
@@ -15,7 +15,7 @@ public class BlockLogicPistonBaseSticky extends BlockLogicPistonBase {
 
     @Override
     public void retractEvent(World world, int x, int y, int z, int data, Direction direction) {
-        TileEntity tileEntity = world.getBlockEntity(x + direction.getOffsetX(), y + direction.getOffsetY(), z + direction.getOffsetZ());
+        TileEntity tileEntity = world.getTileEntity(x + direction.getOffsetX(), y + direction.getOffsetY(), z + direction.getOffsetZ());
         if((tileEntity instanceof TileEntityMovingPistonBlock))
         {
             TileEntityMovingPistonBlock moving = ((TileEntityMovingPistonBlock) tileEntity);
@@ -32,11 +32,11 @@ public class BlockLogicPistonBaseSticky extends BlockLogicPistonBase {
         int z1 = z + direction.getOffsetZ() * 2;
         int retractId = world.getBlockId(x1, y1, z1);
         int retactMeta = world.getBlockMetadata(x1, y1, z1);
-        TileEntity retractEntity = world.getBlockEntity(x1, y1, z1);
+        TileEntity retractEntity = world.getTileEntity(x1, y1, z1);
         boolean pulledMoving = false;
         if(retractId == Blocks.PISTON_MOVING.id())
         {
-            TileEntity tileEntity1 = world.getBlockEntity(x1, y1, z1);
+            TileEntity tileEntity1 = world.getTileEntity(x1, y1, z1);
             if((tileEntity1 instanceof TileEntityMovingPistonBlock))
             {
                 TileEntityMovingPistonBlock movingPistonBlock = (TileEntityMovingPistonBlock) tileEntity1;
diff --git a/game/core/src/main/java/net/minecraft/core/block/piston/BlockLogicPistonMoving.java b/game/core/src/main/java/net/minecraft/core/block/piston/BlockLogicPistonMoving.java
index 8d51ad975..1bb4fb32a 100644
--- a/game/core/src/main/java/net/minecraft/core/block/piston/BlockLogicPistonMoving.java
+++ b/game/core/src/main/java/net/minecraft/core/block/piston/BlockLogicPistonMoving.java
@@ -32,7 +32,7 @@ public class BlockLogicPistonMoving extends BlockLogic
     @Override
     public void onBlockRemoved(World world, int x, int y, int z, int data)
     {
-        TileEntity tileEntity = world.getBlockEntity(x, y, z);
+        TileEntity tileEntity = world.getTileEntity(x, y, z);
         if((tileEntity instanceof TileEntityMovingPistonBlock))
         {
             ((TileEntityMovingPistonBlock) tileEntity).finalTick();
@@ -69,10 +69,10 @@ public class BlockLogicPistonMoving extends BlockLogic
     @Override
     public boolean onBlockRightClicked(World world, int x, int y, int z, Player player, Side side, double xPlaced, double yPlaced)
     {
-        if(!world.isClientSide && world.getBlockEntity(x, y, z) == null)
+        if(!world.isClientSide && world.getTileEntity(x, y, z) == null)
         {
             int id = 0;
-            TileEntityMovingPistonBlock piston = getBlockEntity(world, x, y, z);
+            TileEntityMovingPistonBlock piston = getTileEntity(world, x, y, z);
             if (piston != null) id = piston.getMovedId();
             world.setBlockWithNotify(x, y, z, id);
             return true;
@@ -95,7 +95,7 @@ public class BlockLogicPistonMoving extends BlockLogic
         {
             return;
         }
-        TileEntityMovingPistonBlock piston = getBlockEntity(world, x, y, z);
+        TileEntityMovingPistonBlock piston = getTileEntity(world, x, y, z);
         if(piston != null)
         {
             Blocks.blocksList[piston.getMovedId()].dropBlockWithCause(world, EnumDropCause.WORLD, x, y, z, meta, null, null);
@@ -107,7 +107,7 @@ public class BlockLogicPistonMoving extends BlockLogic
     {
         if(!world.isClientSide)
         {
-            if(world.getBlockEntity(x, y, z) != null);
+            if(world.getTileEntity(x, y, z) != null);
         }
     }
 
@@ -120,7 +120,7 @@ public class BlockLogicPistonMoving extends BlockLogic
     @Override
 	public AABB getCollisionBoundingBoxFromPool(WorldSource world, int x, int y, int z)
     {
-        TileEntityMovingPistonBlock tileEntity = getBlockEntity(world, x, y, z);
+        TileEntityMovingPistonBlock tileEntity = getTileEntity(world, x, y, z);
         if(tileEntity == null)
         {
             return null;
@@ -136,20 +136,20 @@ public class BlockLogicPistonMoving extends BlockLogic
     @Override
     public AABB getBlockBoundsFromState(WorldSource world, int x, int y, int z)
     {
-        TileEntityMovingPistonBlock pistonBlockEntity = getBlockEntity(world, x, y, z);
-        if(pistonBlockEntity != null)
+        TileEntityMovingPistonBlock pistonTileEntity = getTileEntity(world, x, y, z);
+        if(pistonTileEntity != null)
         {
-            Block<?> block = Blocks.blocksList[pistonBlockEntity.getMovedId()];
+            Block<?> block = Blocks.blocksList[pistonTileEntity.getMovedId()];
             if(block == null || block == this.block)
             {
                 return getBlockBoundsFromState(world, x, y, z);
             }
-            float f = pistonBlockEntity.getProgress(0.0F);
-            if(pistonBlockEntity.isExtending())
+            float f = pistonTileEntity.getProgress(0.0F);
+            if(pistonTileEntity.isExtending())
             {
                 f = 1.0F - f;
             }
-            Direction direction = pistonBlockEntity.getDirection();
+            Direction direction = pistonTileEntity.getDirection();
             AABB otherBounds = block.getBlockBoundsFromState(world, x, y, z);
             return AABB.getTemporaryBB(
             otherBounds.minX - direction.getOffsetX() * f,
@@ -184,9 +184,9 @@ public class BlockLogicPistonMoving extends BlockLogic
         }
     }
 
-    private TileEntityMovingPistonBlock getBlockEntity(WorldSource world, int x, int y, int z)
+    private TileEntityMovingPistonBlock getTileEntity(WorldSource world, int x, int y, int z)
     {
-        TileEntity tileEntity = world.getBlockEntity(x, y, z);
+        TileEntity tileEntity = world.getTileEntity(x, y, z);
         if(tileEntity instanceof TileEntityMovingPistonBlock)
         {
             return (TileEntityMovingPistonBlock) tileEntity;
diff --git a/game/core/src/main/java/net/minecraft/core/block/piston/TileEntityMovingPistonBlock.java b/game/core/src/main/java/net/minecraft/core/block/piston/TileEntityMovingPistonBlock.java
index e35cbd94d..1e44799d6 100644
--- a/game/core/src/main/java/net/minecraft/core/block/piston/TileEntityMovingPistonBlock.java
+++ b/game/core/src/main/java/net/minecraft/core/block/piston/TileEntityMovingPistonBlock.java
@@ -146,7 +146,7 @@ public class TileEntityMovingPistonBlock extends TileEntity
         if(worldObj.getBlockId(x, y, z) == Blocks.PISTON_MOVING.id()) {
             worldObj.setBlockAndMetadataRaw(x, y, z, movedId, movedData);
             if (movedEntity != null) {
-                TileEntity oldEnt = worldObj.getBlockEntity(x, y, z);
+                TileEntity oldEnt = worldObj.getTileEntity(x, y, z);
                 if (oldEnt != null) {
                     oldEnt.invalidate();
                 }
@@ -161,7 +161,7 @@ public class TileEntityMovingPistonBlock extends TileEntity
                 Blocks.blocksList[movedId].onBlockPlacedByWorld(worldObj, x, y, z);
                 Block.disableNormalEntityLogic = false;
             }
-            assert movedEntity == null || worldObj.getBlockEntity(x, y, z) == movedEntity : "Piston failed to actually move entity!";
+            assert movedEntity == null || worldObj.getTileEntity(x, y, z) == movedEntity : "Piston failed to actually move entity!";
             worldObj.notifyBlockChange(x, y, z, movedId);
         }
     }
diff --git a/game/core/src/main/java/net/minecraft/core/entity/Entity.java b/game/core/src/main/java/net/minecraft/core/entity/Entity.java
index 920602191..a01d44a32 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/Entity.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/Entity.java
@@ -6,7 +6,6 @@ import java.util.Random;
 import net.minecraft.core.block.BlockLogicFluid;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.entity.vehicle.EntityBoat;
-import net.minecraft.core.entity.vehicle.MobGhastVehicle;
 import net.minecraft.core.util.collection.NamespaceID;
 import net.minecraft.core.util.helper.DyeColor;
 import net.minecraft.core.world.Dimension;
@@ -1228,7 +1227,7 @@ public abstract class Entity
         if (vehicle == null) {
             return;
         }
-        if(vehicle.isRemoved() || (isSneaking() && !(vehicle instanceof MobGhastVehicle)))
+        if(vehicle.isRemoved() || isSneaking())
         {
             vehicle.ejectRider();
             return;
diff --git a/game/core/src/main/java/net/minecraft/core/entity/EntityDispatcher.java b/game/core/src/main/java/net/minecraft/core/entity/EntityDispatcher.java
index 7fb4b9ae6..5c6051b24 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/EntityDispatcher.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/EntityDispatcher.java
@@ -5,8 +5,7 @@ import net.minecraft.core.entity.animal.*;
 import net.minecraft.core.entity.monster.*;
 import net.minecraft.core.entity.projectile.*;
 import net.minecraft.core.entity.vehicle.EntityBoat;
-import net.minecraft.core.entity.vehicle.MinecartEntity;
-import net.minecraft.core.entity.vehicle.MobGhastVehicle;
+import net.minecraft.core.entity.vehicle.EntityMinecart;
 import com.mojang.nbt.tags.CompoundTag;
 import net.minecraft.core.util.collection.NamespaceID;
 import net.minecraft.core.world.World;
@@ -183,7 +182,7 @@ public final class EntityDispatcher
         addMapping(EntityPainting.class, new NamespaceID("minecraft", "painting"));
         addMapping(EntityLightning.class, new NamespaceID("minecraft", "lightning"));
         addMapping(EntityFallingBlock.class, new NamespaceID("minecraft", "falling_block"));
-        addMapping(MinecartEntity.class, new NamespaceID("minecraft", "minecart"));
+        addMapping(EntityMinecart.class, new NamespaceID("minecraft", "minecart"));
         addMapping(EntityBoat.class, new NamespaceID("minecraft", "boat"));
         addMapping(EntityPrimedTNT.class, new NamespaceID("minecraft", "primed_tnt"));
 
@@ -209,7 +208,6 @@ public final class EntityDispatcher
         addMapping(MobGiant.class, new NamespaceID("minecraft", "giant"));
         addMapping(MobSlime.class, new NamespaceID("minecraft", "slime"), "guidebook.section.mob.slime.name");
         addMapping(MobGhast.class, new NamespaceID("minecraft", "ghast"), "guidebook.section.mob.ghast.name");
-        addMapping(MobGhastVehicle.class, new NamespaceID("minecraft", "ghast_vehicle"), "guidebook.section.mob.ghast.name");
         addMapping(MobSnowman.class, new NamespaceID("minecraft", "snowman"), "guidebook.section.mob.snowman.name");
 
         // Passive
@@ -298,7 +296,7 @@ public final class EntityDispatcher
             addMapping(ProjectileFireball.class, "Fireball", 12);
             addMapping(EntityPrimedTNT.class, "PrimedTnt", 20);
             addMapping(EntityFallingBlock.class, "FallingSand", 21);
-            addMapping(MinecartEntity.class, "Minecart", 40);
+            addMapping(EntityMinecart.class, "Minecart", 40);
             addMapping(EntityBoat.class, "Boat", 41);
             addMapping(MobZombieArmored.class, "ArmouredZombie", 42);
             addMapping(ProjectileArrowGolden.class, "ArrowGolden", 43);
diff --git a/game/core/src/main/java/net/minecraft/core/entity/EntityFallingBlock.java b/game/core/src/main/java/net/minecraft/core/entity/EntityFallingBlock.java
index 518d11a4d..25e249c0c 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/EntityFallingBlock.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/EntityFallingBlock.java
@@ -134,7 +134,7 @@ public class EntityFallingBlock extends Entity
                 } else if (!world.isClientSide) {
                     world.setBlockMetadata(x, y, z, carriedBlock.metadata);
                     if (carriedBlock.entity != null) {
-                        TileEntity oldEnt = world.getBlockEntity(x, y, z);
+                        TileEntity oldEnt = world.getTileEntity(x, y, z);
                         if (oldEnt != null) {
                             oldEnt.invalidate();
                         }
@@ -149,7 +149,7 @@ public class EntityFallingBlock extends Entity
                     world.notifyBlockChange(x, y, z, carriedBlock.blockId);
                 }
                 if (rider != null) {
-                    TileEntity te = world.getBlockEntity(x, y, z);
+                    TileEntity te = world.getTileEntity(x, y, z);
                     if (te instanceof IVehicle) rider.startRiding((IVehicle) te);
                 }
             } else if(fallTime > 600 && !world.isClientSide) {
